<template>
  <div class="sw-gs-widget-cross-selling">
    <SfLoader class="widget-loader" :loading="isLoading" v-if="isLoading"/>
    <template v-else>
      <SfAccordion v-if="crossSellCollection && crossSellCollection.length >= 1" transition="false" showChevron>
        <SwGsAccordionItem v-for="(crossSellItem, index) in crossSellCollection"
                           :key="'cross-sells-item-'+ index"
                           :header="getTranslatedProperty(crossSellItem.crossSelling, 'name')"
                           class="cross-sells-item">
          <SwGsLayerProductCardHorizontal v-for="(crossSellProduct, index) in crossSellItem.products"
                                          :key="'cross-sells-item-product-'+ index"
                                          :product="crossSellProduct"></SwGsLayerProductCardHorizontal>
        </SwGsAccordionItem>
        <SwGsAccordionItem v-if="crossSellTopMatches && crossSellTopMatches.length >= 1"
                           :header="$t('Top matches')"
                           class="cross-sells-item">
          <SwGsLayerProductCardHorizontal v-for="(topMatch, index) in crossSellTopMatches"
                                          :key="'cross-sells-top-item-product-'+ index"
                                          :product="topMatch"></SwGsLayerProductCardHorizontal>
        </SwGsAccordionItem>
      </SfAccordion>
      <div v-else>
        <span>{{ $t('No cross selling.') }}</span>
      </div>
    </template>
  </div>
</template>

<script lang="ts">
  import {onMounted, ref, watch} from "@vue/composition-api"
  import {SfAccordion, SfLoader} from "@storefront-ui/vue";
  import SwGsAccordionItem from "../layer/SwGsAccordionItem.vue";
  import SwGsLayerProductCardHorizontal from "../layer/SwGsLayerProductCardHorizontal.vue";
  import {getTranslatedProperty} from "@shopware-pwa/helpers"
  import {useCrossSelling} from "../../logic/composables/widgets/useCrossSelling";

  export default {
    name: "SwGsCrossselling",
    components: {
      SfLoader,
      SfAccordion,
      SwGsAccordionItem,
      SwGsLayerProductCardHorizontal
    },
    props: {
      slotContext: {
        type: [Object, Array, String],
        default: null,
      },
    },
    setup(props, {}) {
      const isLoading = ref(false)
      const product = ref(props.slotContext);

      const {
        loadCrossSellCollection,
        loadCrossSellTopMatches,
        crossSellCollection,
        crossSellTopMatches
      } = useCrossSelling(product.value);

      onMounted(async () => {
        isLoading.value = true;
        await loadCrossSellCollection();
        await loadCrossSellTopMatches();
        isLoading.value = false;
      })

      watch(product, (newProductValue) => {
        if (!newProductValue) return;
        loadCrossSellCollection();
      });

      return {
        product,
        loadCrossSellCollection,
        loadCrossSellTopMatches,
        crossSellCollection,
        crossSellTopMatches,
        getTranslatedProperty,
        isLoading
      }
    }
  }
</script>

<style lang="scss" scoped>
  @import "@/assets/scss/variables";

  .widget-loader {
    height: 50px;
  }

  .sw-gs-widget-cross-selling {
    margin-bottom: 10px;

    ::v-deep {
      .sf-accordion-item {
        border-bottom: 2px solid var(--c-primary);
      }

      .sf-accordion-item__header {
        padding: 8px 0;
      }

      .sf-product-card-horizontal:hover {
        box-shadow: none;
      }
    }
  }
</style>
